<template>
  <div v-if="showBanner" class="subscription-banner">
    <p>¡Suscríbete para recibir las últimas notificaciones!</p>
    <button class="button" @click="subscribeUser">Suscribirse</button>
  </div>

  <UnsubscribeButton v-if="subscription" :subscription="subscription" @unsubscribed="init()" />
</template>

<script lang="ts">
import webPushService from '@/services/webPush/webPushService';
import webPushFunctions from './webPushFunctions';
import UnsubscribeButton from './UnsubscribeButton.vue';

export default {
  name: 'subscription-button',
  data() {
    return {
      showBanner: false,
      permission: webPushFunctions.checkPermission(),
      subscription: null as PushSubscription | null
    };
  },
  components: { UnsubscribeButton },
  created() {
    this.init();
  },
  methods: {
    async init() {
      this.subscription = await webPushFunctions.checkSubscription();
      this.showBanner = await webPushFunctions.showSubscriptionBanner();
    },
    async requestPermission() {
      if (!('Notification' in window) || !('PushManager' in window) || !('serviceWorker' in navigator)) {
        alert('Tu navegador no soporta el servicio de notificaciones');
        return false;
      }
      // Solicitamos permiso para enviar notificaciones
      this.permission = await Notification.requestPermission();
      return this.permission === 'granted' ? true : false;
    },
    async subscribeUser() {
      if (this.permission === 'denied') {
        alert('No tienes permiso para enviar notificaciones, revisa la configuración de sitios de tu navegador.');
        return;
      }
      if (this.permission === 'default' && !await this.requestPermission()) {
        alert("Se ha denegado el permiso para enviar notificaciones.");
        return;
      }
      try {
        this.subscription = await webPushFunctions.subscribe();
        await webPushService.subscribe(this.subscription);
        this.init();
        alert('Suscripción exitosa');
      }
      catch (error) {
        alert(`Error al suscribirse ${error}`);
      }
    }
  }
}
</script>

<style scoped>
.subscription-banner {
  position: fixed;
  top: 0;
  left: 0;
  width: calc(100% - 20px);
  z-index: 999;
  display: flex;
  justify-content: space-between;
  align-items: center;
  background-color: #f9f9f9;
  padding: 10px;
  border: 1px solid #ccc;
  border-radius: 5px;
  margin: 10px;
  box-sizing: border-box;
}

.subscription-banner p {
  margin: 0;
  font-size: 16px;
}

.button {
  padding: 10px 20px;
  border: none;
  border-radius: 5px;
  background-color: #ff9900;
  color: white;
  cursor: pointer;
  font-size: 16px;
  transition: background-color 0.3s;
}

.button:hover {
  background-color: #cc7700;
}
</style>
